--Addon: RaidScore
--Game: The Elder Scrolls Online: Tamriel Unlimited
--Author: Woeler

local RS = {
	Menu = LibStub:GetLibrary("LibAddonMenu-2.0"),
	hideScore = false,
	lockScore = false,
	}

--function for getting the current score
function RaidScoreUpdate()
	RAIDSCORECounter:SetText(string.format(GetCurrentRaidScore()))
end

function RaidDeathsUpdate()
	deathCounter = 0
	if GetCurrentRaidDeaths() == nil then
	deathCounter = 0
	else
	deathCounter = 0 + GetCurrentRaidDeaths()
	end
	RAIDSCOREDeaths:SetText(string.format(deathCounter))
end


 
    local savedVariables --local reference for saved variables, actual object will be assigned later in EVENT_ADD_ON_LOADED event handler
    local defaults = { --default values for saved variables
        offsetX = 200,
        offsetY = 200,
		HideScores = false,
		lockWindow = false,
		postResults = true,
		HideTotalScore = false,
		HideDeaths = false,
    }
     
    --event handler for OnMoveStop
    local function OnMoveStop(self)
        savedVariables.offsetX = self:GetLeft()
        savedVariables.offsetY = self:GetTop()
    end
     
    --event handler for EVENT_ADD_ON_LOADED
    local function OnAddonLoaded(event, addonName)
        if addonName == "RaidScore" then --addonName is in general name of your addon manifext without .txt extension
			RS.Menu:RegisterAddonPanel("RaidScorePanel", RS.panelData)
			RS.Menu:RegisterOptionControls("RaidScorePanel", RS.optionsData)
     
            EVENT_MANAGER:UnregisterForEvent(MoveHandler, EVENT_ADD_ON_LOADED)
			ZO_CreateStringId("SI_BINDING_NAME_TOGGLEHIDDEN", "Toggle hidden")
			ZO_CreateStringId("SI_BINDING_NAME_POSTSCORE", "Post current score")
     
            --saved variables (in this case account wide)
            savedVariables = ZO_SavedVars:NewAccountWide("RaidScore", 1, "namespace", defaults)
     
            --create top level window, so we have something to work with
            RAIDSCORE:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, savedVariables.offsetX, savedVariables.offsetY) --restore window position from saved variables
            RAIDSCORE:SetHandler("OnMoveStop", OnMoveStop) --set handler to event "OnMoveStop", it means when you stop moving the window
			RAIDSCORE:SetHidden(savedVariables.HideScores) --set window invisible or visible
			RAIDSCORE:SetMovable(savedVariables.lockWindow) --lock the window in place or not
			RAIDSCOREtext:SetHidden(savedVariables.HideTotalScore)
			RAIDSCORECounter:SetHidden(savedVariables.HideTotalScore)
			RAIDSCOREtext2:SetHidden(savedVariables.HideDeaths)
			RAIDSCOREDeaths:SetHidden(savedVariables.HideDeaths)
		

        end
    end

function ToggleHidden()
	if savedVariables.HideScores == true then
		RAIDSCORE:SetHidden(false)
		savedVariables.HideScores = false
	elseif savedVariables.HideScores == false then
		RAIDSCORE:SetHidden(true)
		savedVariables.HideScores = true
	end
end

function PostScore()
	if savedVariables.postResults == true then
	d("|cFF0000Current trial score: "..GetCurrentRaidScore())
	end
end

function PostEndScore()
	if savedVariables.postResults == true then
	d("|c4CFF00~~~~Trial Completed~~~~")
	d("|c4CFF00You have a total score of "..GetCurrentRaidScore().." points.")
	d("|c4CFF00Your group suffered "..GetCurrentRaidDeaths().." deaths.")
	end
end


------Creating the menu with LibAddonMenu-2.0 (thank you Seerah)-------	
	RS.panelData = {
		type = "panel",
		name = "RaidScore",
		author = "Woeler",
		version = "1.2.1",
		registerForRefresh = false,
		}
		
	
	RS.optionsData = {
		[1] = {
		type = "description",
		text = "Welcome to RaidScore by Woeler (EU: @Woeler)",
		width = "full",
		},
		[2] = {
            type = "checkbox",
            name = "Show RaidScore",
            tooltip = "Toggle RaidScore visible.",
            getFunc = function() return not savedVariables.HideScores end,
            setFunc = function(value)
                --RS.hideScore = not value
				savedVariables.HideScores = not value
                RAIDSCORE:SetHidden(savedVariables.HideScores)
            end,
        },
		[3] = {
            type = "checkbox",
            name = "Show Score",
            tooltip = "Toggle Score visible.",
            getFunc = function() return not savedVariables.HideTotalScore end,
            setFunc = function(value)
                --RS.hideScore = not value
				savedVariables.HideTotalScore = not value
                RAIDSCOREtext:SetHidden(savedVariables.HideTotalScore)
				RAIDSCORECounter:SetHidden(savedVariables.HideTotalScore)
            end,
        },
		[4] = {
            type = "checkbox",
            name = "Show Deathcounter",
            tooltip = "Toggle the deathcounter visible.",
            getFunc = function() return not savedVariables.HideDeaths end,
            setFunc = function(value)
                --RS.hideScore = not value
				savedVariables.HideDeaths = not value
                RAIDSCOREtext2:SetHidden(savedVariables.HideDeaths)
				RAIDSCOREDeaths:SetHidden(savedVariables.HideDeaths)
            end,
        },
		[5] = {
            type = "checkbox",
            name = "Lock window",
            tooltip = "Lock the RaidScore window in place.",
            getFunc = function() return not savedVariables.lockWindow end,
            setFunc = function(value)
				savedVariables.lockWindow = not value
                RAIDSCORE:SetMovable(savedVariables.lockWindow)
            end,
        },
		[6] = {
            type = "checkbox",
            name = "Post end results in chat",
            tooltip = "When a trial is completed post the score and deaths in the chatbox (only visible to you!).",
            getFunc = function() return savedVariables.postResults end,
            setFunc = function(value)
				savedVariables.postResults = value
            end,
        },
		[7] = {
		type = "description",
		text = "A quick note about the deathcounter. The deathcounter shows the number of dead players that have been resurrected in the raid.",
		width = "full",
		},


		width = "full",
		
	},
   
	


    EVENT_MANAGER:RegisterForEvent(MoveHandler, EVENT_ADD_ON_LOADED, OnAddonLoaded)
	EVENT_MANAGER:RegisterForEvent("RAID_SCORE_POST", EVENT_RAID_TRIAL_COMPLETE, PostEndScore)